###############################################################################
#                                                                             #
# Settings_PicasaGallery.pm  by XTC                                           #
#                                                                             #
###############################################################################
#                                                                             #
# Version:        Beta 1				                      #
# Date:           09 / 2014                                                   #
# Distributed by: http://www.yabbserver.com                                   #
#                                                                             #
# =========================================================================== #
#                                                                             #
# NOTE: Picasa is a registered trademark of Google Inc.                       #
#       The author declines every responsability about this software          #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2014 YaBB Server (www.yabbserver.com) - All Rights Reserved.  #
#       The author declines every responsability about this software          #
#                                                                             #
###############################################################################

$settings_picasagallerypmver = 'PicasaGallery $Revision: Beta1';
if ( $action eq 'detailedversion' ) { return 1; }

LoadLanguage("SetPicasaGallery");

    if ( !-e "$vardir/gallery_header.txt") {
	fopen(GDAT, ">$vardir/gallery_header.txt");
	fclose(GDAT);
	chmod(0666, "$vardir/gallery_header.txt");
    }

    fopen( GALHEADER, "$vardir/gallery_header.txt" ) || fatal_error( 'cannot_open', 'gallery_header.txt', 1 );
        @galleryheader = <GALHEADER>;
    fclose( GALHEADER );

        @gallery_header = join q{}, @galleryheader;

# Picasa Gallery Defaults
require Admin::ManageBoards;
## figure out if print gallery tab to AdvancedTabs ##
if ( $picasatab ) {
$picasatabif = 0;
	foreach(@AdvancedTabs) {
		if( $_ =~ /^gallery/ ) { $picasatabif = 1; }
	}
	if ( $picasatabif == 0 ) { 
		push(@AdvancedTabs, "gallery");

		require "$admindir/NewSettings.pm";
		SaveSettingsTo('Settings.pm', %settings);

		$yySetLocation = qq~$adminurl?action=newsettings;page=gallery~;
		redirectexit();
	}
}

if    ( $picasatab eq q{} ) 			{ $picasatab = 1;
				  	$tab_info_id = qq~
					<a href="#tab_gallhelp" onclick="changeToTab('gallhelp'); return false;" title="$gallery_set{'picasaid_how'}">$gallery_set{'picasaid_how'}</a>
				  	~;					}
if    ( $linkpicasa eq q{} ) 		{ $linkpicasa = 1; 			}
if    ( $linkpicasaindex eq q{} ) 	{ $linkpicasaindex = 1; 		}
if    ( $linkgalleria eq q{} ) 		{ $linkgalleria = 1; 			}
if    ( $linkdivviewer eq q{} ) 	{ $linkdivviewer = 1; 			}
if    ( $linkpicasaflash eq q{} ) 	{ $linkpicasaflash = 1; 		}
if    ( $thumb_alb_size eq q{} ) 	{ $thumb_alb_size  = 160; 		}
if    ( $thumb_alb_c_u eq q{} ) 	{ $thumb_alb_c_u  = 'c'; 		}
if    ( $thumb_index_size eq q{} ) 	{ $thumb_index_size  = 160; 		}
if    ( $thumb_index_c_u eq q{} ) 	{ $thumb_index_c_u   = 'u'; 		}
if    ( $galleria_width eq q{} ) 	{ $galleria_width  = 620; 		}
if    ( $galleria_height eq q{} ) 	{ $galleria_height  = 450; 		}
if    ( $galleria_theme eq q{} ) 	{ $galleria_theme  = "classic"; 	}
if    ( $thumb_divviewer_size eq q{} ) 	{ $thumb_divviewer_size  = 160; 	}
if    ( $thumb_divviewer_c_u eq q{} ) 	{ $thumb_divviewer_c_u  = 'c'; 		}
if    ( $picasa_flash_width eq q{} ) 	{ $picasa_flash_width  = 3; 		}
if    ( $picasa_flash_color eq q{} ) 	{ $picasa_flash_color  = "\#000000";	}

# Style selector Plugin Galleria

$galstyledir = "$htmldir/PicasaGallery/plugins/galleria/themes";
opendir GALSTYL, $galstyledir;
my @sfilesgalleria = readdir GALSTYL;
closedir GALSTYL;
foreach my $sgd (sort {lc($a) cmp lc $b} @sfilesgalleria) {
    if (-e "$galstyledir/$sgd/galleria.$sgd.css") {
      my $dispstyle = $sgd;
        $dispstyle =~ s/(.+?)\_(.+?)$/$1 ($2)/gism;
        $galsdirs .= qq~<option value="$sgd" ${isselected($sgd eq $galleria_theme)}>$dispstyle</option>~;
    }
}

$go_picasa = qq~<a href="https://picasaweb.google.com" title="picasaweb.google.com" target="_blank"><img src="$yyhtml_root/PicasaGallery/wwpicasa190x50.gif" alt="" /></a>~;

# List of settings
@settings = (
    {
        name  => $gallery_set{'set1'},
        id    => 'gallery',
        items => [
            {
                header => $go_picasa,
            },
            {
                description =>
                  qq~<label for="picasaid">$gallery_set{'picasaid'}</label>~,
                input_html =>
qq~<br /><input type="text" name="picasaid" id="picasaid" size="25" value="$picasaid" /> $tab_info_id~,
                name     => 'picasaid',
            },
            {
                header => $gallery_set{'set4'},
            },
            {
                description =>
		  qq~<label for="picasagroups">$gallery_set{'picasagroups'}</label>~,
                input_html =>
		  qq~<select name="picasagroups" id="picasagroups">
			<option value="0" ${isselected($picasagroups == 0)}>$userlevel_txt{'none'}</option>
			<option value="1" ${isselected($picasagroups == 1)}>$userlevel_txt{'all'}</option>
			<option value="2" ${isselected($picasagroups == 2)}>$userlevel_txt{'members'}</option>
			<option value="3" ${isselected($picasagroups == 3)}>$userlevel_txt{'modgmodadmin'}</option>
			<option value="4" ${isselected($picasagroups == 4)}>$userlevel_txt{'gmodadmin'}</option>
		      </select>~,
                name => 'picasagroups',
                validate => 'number',
            },
            {
                description => qq~<label for="picasamemgroups">$gallery_set{'picasamemgroups'}</label>~,
                input_html => q~<select multiple="multiple" name="picasamemgroups" id="picasamemgroups" size="8">~ . DrawPerms($picasamemgroups, 0) . q~</select>~,
                name => 'picasamemgroups',
                validate => 'text,null',
                depends_on => ['$picasagroups==2'],
            },
            {
                description =>
qq~<label for="picasatab">$gallery_set{'picasatab'}</label>~,
                input_html =>
qq~<input type="checkbox" name="picasatab" id="picasatab" value="1"${ischecked($picasatab)} />~,
                name     => 'picasatab',
                validate => 'boolean',
            },
            {
                header => $gallery_set{'set5'},
            },
            {
                description =>
		  qq~<label for="thumb_alb_size">$gallery_set{'thumb_alb_size'}</label>~,
                input_html =>
qq~<input type="text" name="thumb_alb_size" id="thumb_alb_size" size="5" value="$thumb_alb_size" /> pixel~,
                name => 'thumb_alb_size',
                validate => 'number',
            },
            {
                description =>
		  qq~<label for="thumb_alb_c_u">$gallery_set{'thumb_c_u'}</label>~,
                input_html =>
		  qq~<select name="thumb_alb_c_u" id="thumb_alb_c_u">
			<option value="c" ${isselected($thumb_alb_c_u eq 'c')}>$gallery_set{'cropped'}</option>
			<option value="u" ${isselected($thumb_alb_c_u eq 'u')}>$gallery_set{'uncropped'}</option>
		      </select>~,
                name => 'thumb_alb_c_u',
            },
            {
                description =>
qq~<label for="linkpicasa">$gallery_set{'linkpicasa'}</label>~,
                input_html =>
qq~<input type="checkbox" name="linkpicasa" id="linkpicasa" value="1"${ischecked($linkpicasa)} />~,
                name     => 'linkpicasa',
                validate => 'boolean',
            },
            {
                header => $gallery_set{'set6'},
            },
            {
                description => qq~<label for="thumb_index_size">$gallery_set{'thumb_index_size'}</label>~,
                input_html =>
qq~<input type="text" name="thumb_index_size" id="thumb_index_size" size="5" value="$thumb_index_size" /> pixel~,
                name       => 'thumb_index_size',
                validate   => 'number',
            },
            {
                description =>
		  qq~<label for="thumb_index_c_u">$gallery_set{'thumb_c_u'}</label>~,
                input_html =>
		  qq~<select name="thumb_index_c_u" id="thumb_index_c_u">
			<option value="c" ${isselected($thumb_index_c_u eq 'c')}>$gallery_set{'cropped'}</option>
			<option value="u" ${isselected($thumb_index_c_u eq 'u')}>$gallery_set{'uncropped'}</option>
		      </select>~,
                name => 'thumb_index_c_u',
            },
            {
                description =>
qq~<label for="linkpicasa">$gallery_set{'linkpicasaindex'}</label>~,
                input_html =>
qq~<input type="checkbox" name="linkpicasaindex" id="linkpicasaindex" value="1"${ischecked($linkpicasaindex)} />~,
                name     => 'linkpicasaindex',
                validate => 'boolean',
            },
        ],
    },
    {
        name  => $gallery_set{'set2'},
        id    => 'gallheader',
        items => [
            {
                header => $gallery_set{'set2'},
            },
            {
                description =>
qq~<label for="show_gallery_header">$gallery_set{'show_gallery_header'}</label>~,
                input_html =>
qq~<input type="checkbox" name="show_gallery_header" id="show_gallery_header" value="1"${ischecked($show_gallery_header)} />~,
                name     => 'show_gallery_header',
                validate => 'boolean',
            },
            {
                description =>
qq~<label for="galleryheader">$gallery_set{'info_gallery_header'}</label>~,
                input_html =>
qq~<textarea cols="60" rows="35" name="galleryheader" id="galleryheader" style="width: 95%">$gallery_header[0]</textarea>~,
                two_rows => 1,
                name     => 'galleryheader',
                validate => 'fulltext,null',
            },
        ],
    },
    {
        name  => $gallery_set{'set3'},
        id    => 'gallplugin',
        items => [
            {
                header => $gallery_set{'set7'},
            },
            {
                description =>
qq~<label for="linkgalleria">$gallery_set{'linkgalleria'}</label>~,
                input_html =>
qq~<input type="checkbox" name="linkgalleria" id="linkgalleria" value="1"${ischecked($linkgalleria)} />~,
                name     => 'linkgalleria',
                validate => 'boolean',
            },
            {
                description =>
                  qq~<label for="galleria_width">$gallery_set{'galleria_width'}</label>~,
                input_html =>
qq~<input type="text" name="galleria_width" id="galleria_width" size="5" value="$galleria_width" /> pixel~,
                name     => 'galleria_width',
                validate => 'number',
            },
            {
                description =>
                  qq~<label for="galleria_height">$gallery_set{'galleria_height'}</label>~,
                input_html =>
qq~<input type="text" name="galleria_height" id="galleria_height" size="5" value="$galleria_height" /> pixel~,
                name     => 'galleria_height',
                validate => 'number',
            },
            {
                description =>
		  qq~<label for="galleria_theme">$gallery_set{'galleria_theme'}</label>~,
                input_html =>
		  qq~<select name="galleria_theme" id="galleria_theme">$galsdirs</select>~,
                name => 'galleria_theme',
                validate   => 'text',
            },
            {
                header => $gallery_set{'set10'},
            },
            {
                description =>
qq~<label for="linkdivviewer">$gallery_set{'linkdivviewer'}</label>~,
                input_html =>
qq~<input type="checkbox" name="linkdivviewer" id="linkgalleria" value="1"${ischecked($linkdivviewer)} />~,
                name     => 'linkdivviewer',
                validate => 'boolean',
            },
            {
                description => qq~<label for="thumb_divviewer_size">$gallery_set{'thumb_index_size'}</label>~,
                input_html =>
qq~<input type="text" name="thumb_divviewer_size" id="thumb_divviewer_size" size="5" value="$thumb_divviewer_size" /> pixel~,
                name       => 'thumb_divviewer_size',
                validate   => 'number',
            },
            {
                description =>
		  qq~<label for="thumb_divviewer_c_u">$gallery_set{'thumb_c_u'}</label>~,
                input_html =>
		  qq~<select name="thumb_divviewer_c_u" id="thumb_index_c_u">
			<option value="c" ${isselected($thumb_divviewer_c_u eq 'c')}>$gallery_set{'cropped'}</option>
			<option value="u" ${isselected($thumb_divviewer_c_u eq 'u')}>$gallery_set{'uncropped'}</option>
		      </select>~,
                name => 'thumb_divviewer_c_u',
            },
            {
                header => $gallery_set{'set11'},
            },
            {
                description =>
qq~<label for="linkgalleria">$gallery_set{'linkgalleria'}</label>~,
                input_html =>
qq~<input type="checkbox" name="linkpicasaflash" id="linkpicasaflash" value="1"${ischecked($linkpicasaflash)} />~,
                name     => 'linkpicasaflash',
                validate => 'boolean',
            },
            {
                description =>
		  qq~<label for="picasa_flash_width">$gallery_set{'picasa_flash_width'}</label>~,
                input_html =>
		  qq~<select name="picasa_flash_width" id="picasa_flash_width">
			<option value="0" ${isselected($picasa_flash_width == 0)}>$gallery_set{'picasa_flash_0'}</option>
			<option value="1" ${isselected($picasa_flash_width == 1)}>$gallery_set{'picasa_flash_1'}</option>
			<option value="2" ${isselected($picasa_flash_width == 2)}>$gallery_set{'picasa_flash_2'}</option>
			<option value="3" ${isselected($picasa_flash_width == 3)}>$gallery_set{'picasa_flash_3'}</option>
			<option value="4" ${isselected($picasa_flash_width == 4)}>$gallery_set{'picasa_flash_4'}</option>
		      </select>~,
                name => 'picasa_flash_width',
                validate => 'number',
            },
            {
            description =>
                  qq~<label for="picasa_flash_color">$gallery_set{'picasa_flash_color'}</label>~,
                input_html =>
qq~<input type="text" size="7" maxlength="7" name="picasa_flash_color" id="picasa_flash_color" value="$picasa_flash_color" onkeyup="previewColor(this.value);" /> <span id="picasa_flash_color2" style="background-color:$picasa_flash_color">&nbsp; &nbsp; &nbsp;</span> <img src="$defaultimagesdir/palette1.gif" align="top" style="cursor: pointer" onclick="window.open('$scripturl?action=palette;task=templ', '', 'height=308,width=302,menubar=no,toolbar=no,scrollbars=no')" alt="" border="0" />
                <script type="text/javascript">
                <!--
                function previewColor(color) {
                    document.getElementById('picasa_flash_color2').style.background = color;
                    document.getElementsByName("picasa_flash_color")[0].value = color;
                }
                //-->
                </script>~,
                name => 'picasa_flash_color',
                validate => 'text',
            },
        ],
    },
    {
        name  => $img_txt{'119'},
        id    => 'gallhelp',
        items => [
            {
                description =>
qq~<label for="helpsetup"><br /><b>$gallery_set{'set8'}</b><br /><br /></label>~,
                input_html =>
qq~<span class="small">$gallery_mod_install<br /><img src="$yyhtml_root/PicasaGallery/picasa-settings.jpg" alt="" /><br /><br /></span>~,
                two_rows => 1,
            },
            {
                description =>
qq~<label for="helpsetup"><br /><b>$gallery_set{'set9'}</b><br /><br /></label>~,
                input_html =>
qq~<span class="small">$gallery_album_setup</span>~,
                two_rows => 1,
            },
            {
                description =>
qq~<label for="helpheader"><br /><b>$gallery_set{'set2'}</b><br /><br /></label>~,
                input_html =>
qq~<span class="small">$info_gallery_header</span>~,
                two_rows => 1,
            },
        ],
    },
);



# Routine to save the Picasa Gallery settings
sub SaveSettings {
    my %settings = @_;

if ( $settings{'picasagroups'} != 2 ) { $settings{'picasamemgroups'} = ''; }

    # GALH
#   $settings{'galleryheader'} =~ s/\r(?=\n*)//gxsm;
    fopen( GALH, ">$vardir/gallery_header.txt" );
    print {GALH} delete $settings{'galleryheader'} or croak "$croak{'print'} GALH";
    fclose(GALH);

   SaveSettingsTo('Settings.pm', %settings);
    return;
}

sub ischecked2 {
    my ($inp) = @_;

    # Return a ref so we can be used like ${ischecked($var)} inside a string
    if ($inp == 1 ) { return 1 ;}
    return;
}

1;
